/*******************************************************************************
 * global objects
 ******************************************************************************/
var employeesCells = [
  function(employee) { return employee.name; },
  function(employee) { return employee.address; },
  function(employee) { return employee.lastUpdateDate; },
  function(employee) {
    return '<input type="button" value="폜" onclick="displayOperation(\''
      + "removal" + '\', onDisplayRemoval, { id:\''
      + employee.id + '\', name:\'' + employee.name + '\', address:\''
      + employee.address + '\', lastUpdateDate:\'' + employee.lastUpdateDate
      + '\' });" />';
  }
];

var employee = {
  name: null,
  address: null,
  clear: function() {
    this.name = null;
    this.address = null;
  }
};

var validation = {
  name: false,
  address: false,
  update: function() {
    if (!this.name || !this.address) {
      $("addition-add").disabled = true;
    } else {
      $("addition-add").disabled = false;
    }
  },
  clear: function() {
    this.name = false;
    this.address = false;
    $("addition-add").disabled = true;
  }
};

/*******************************************************************************
 * filter employees
 ******************************************************************************/
function filterEmployees() {
  AjaxFacade.filterEmployees(fillEmployeesTable, $("filterWord").value);
}

function fillEmployeesTable(employees) {
  DWRUtil.removeAllRows("employees");
  DWRUtil.addRows("employees", employees, employeesCells);
}

/*******************************************************************************
 * add employee
 ******************************************************************************/
function addEmployee() {
  DWRUtil.getValues(employee);
  AjaxFacade.addEmployee(updateAll, employee);
  hideOperation("addition", onHideAddition);
}

function onDisplayAddition() {
  $("filterWord").disabled = true;
}

function onHideAddition() {
  $("filterWord").disabled = false;
  employee.clear();
  DWRUtil.setValues(employee);
  validation.clear();
  DWRUtil.setValue("error-name", null);
  DWRUtil.setValue("error-address", null);
}

function validateName() {
  AjaxFacade.isValidEmployeeName(
    replyNameValidation, DWRUtil.getValue("name"));
}

function replyNameValidation(errorMessages) {
  validation.name = errorMessages.length == 0;
  updateErrorSpan("error-name", errorMessages);
  validation.update();
}

function validateAddress() {
  AjaxFacade.isValidEmployeeAddress(
    replyAddressValidation, DWRUtil.getValue("address"));
}

function replyAddressValidation(errorMessages) {
  validation.address = errorMessages.length == 0;
  updateErrorSpan("error-address", errorMessages);
  validation.update();
}

function updateErrorSpan(id, errorMessages) {
  var errorMessage = "";
  for (var i = 0; i < errorMessages.length; i++) {
    errorMessage += errorMessages[i];
  }
  DWRUtil.setValue(id, errorMessage);
}

/*******************************************************************************
 * remove employee
 ******************************************************************************/
function removeEmployee(employeeId) {
  AjaxFacade.removeEmployee(updateAll, { id: employeeId });
  hideOperation("removal", onHideRemoval);
}

function onDisplayRemoval(employee) {
  $("filterWord").disabled = true;
  if (employee == undefined || employee.id == undefined) {
    window.alert("IllegalArgument: employee or employee.id is undefined.");
    hideOperation("removal", onHideRemoval);
    return;
  }
  if (employee.name != undefined) {
    DWRUtil.setValue("removal-name", employee.name);
  }
  if (employee.address != undefined) {
    DWRUtil.setValue("removal-address", employee.address);
  }
  if (employee.lastUpdateDate != undefined) {
    DWRUtil.setValue(
      "removal-lastUpdateDate", employee.lastUpdateDate);
  }
  $("removal-remove").onclick = function() {
    removeEmployee(employee.id);
  };
}

function onHideRemoval() {
  $("filterWord").disabled = false;
//  DWRUtil.setValue("removal-name", null);
//  DWRUtil.setValue("removal-address", null);
//  DWRUtil.setValue("removal-lastUpdateDate", null);
  $("removal-remove").onclick = null;
}

/*******************************************************************************
 * update history
 ******************************************************************************/
function updateHistory() {
  AjaxFacade.getEmployeeUpdateHistoryHTML(replyUpdateHistoryHTML, 5);
}

function replyUpdateHistoryHTML(updateHistoryHTML) {
  $("update-history-list").innerHTML = updateHistoryHTML;
}

/*******************************************************************************
 * repeat update
 ******************************************************************************/
var INTERVAL_ID = null;

function repeatUpdate() {
  $("auto-update-on").disabled = true;
  $("auto-update-off").disabled = false;
  INTERVAL_ID = setInterval("updateAll();", 1000 * 30); // 30sec
}

function stopRepeatingUpdate() {
  $("auto-update-on").disabled = false;
  $("auto-update-off").disabled = true;
  clearInterval(INTERVAL_ID);
}

/*******************************************************************************
 * update all
 ******************************************************************************/
function updateAll() {
  filterEmployees();
  updateHistory();
}

/*******************************************************************************
 * initialization
 ******************************************************************************/
function init() {
  DWRUtil.useLoadingMessage();
  updateAll();
  stopRepeatingUpdate();
  new Draggable("addition");
  new Draggable("removal");
}