package com.mamezou.employee.dataaccess.springjdbc;

import java.util.List;


import org.springframework.jdbc.core.simple.ParameterizedRowMapper;
import org.springframework.jdbc.core.simple.SimpleJdbcDaoSupport;

import com.mamezou.employee.business.Employee;
import com.mamezou.employee.business.EmployeeDao;

/**
 * ]ƈǗDAO
 * @author MBeans
 * @version 1.0
 */
public class EmployeeDaoImpl
        extends SimpleJdbcDaoSupport implements EmployeeDao {

    private static final String EMP_QUERY
            = "SELECT id, name, address, last_update_date FROM employee";
    private static final String INSERT_EMP
            = "INSERT INTO employee VALUES(?, ?, ?, ?)";
    private static final String DELETE_EMP
            = "DELETE FROM employee WHERE id = ?";
    
    /**
     * SĂ̏]ƈB
     * @return SĂ̏]ƈ
     */
    public List<Employee> findAll() {
        ParameterizedRowMapper<Employee> pr
            = new ParameterizedRowMapper<Employee>() {
                public Employee mapRow(java.sql.ResultSet rs, int rownum)
                        throws java.sql.SQLException {
                    Employee emp = new Employee();
                    emp.setId(rs.getInt("id"));
                    emp.setName(rs.getString("name"));
                    emp.setAddress(rs.getString("address"));
                    emp.setLastUpdateDate(rs.getTimestamp("last_update_date"));
                    return emp;
                }
            };
        return getSimpleJdbcTemplate().query(EMP_QUERY, pr);
    }

    /**
     * ]ƈǉB
     * @param emp ]ƈNX
     * @return ǉ]ƈ
     */
    public int addEmployee(Employee emp) {
        return getSimpleJdbcTemplate().update(
                INSERT_EMP, null, emp.getName(), emp.getAddress(),
                emp.getLastUpdateDate());
    }

    /**
     * ]ƈ폜B
     * @param emp ]ƈNX
     * @return 폜]ƈ
     */
    public int removeEmployee(Employee emp) {
        return getSimpleJdbcTemplate().update(DELETE_EMP, emp.getId());
    }
}
