/*
 * HsqldbServerListener.java
 */
package com.mamezou.utils.hsql;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

/**
 * @author MBeans
 * @version 1.0
 */
public class HsqldbServerListener implements ServletContextListener {

    private HsqldbServer hsqldbServer;

    public void contextInitialized(ServletContextEvent servletContextEvent) {
        ServletContext servletContext = servletContextEvent.getServletContext();
        hsqldbServer = new HsqldbServer(getHsqldbDatabase(servletContext));
        hsqldbServer.start();
    }

    private String getHsqldbDatabase(ServletContext servletContext) {
        String database
                = servletContext.getInitParameter("hsqldbDatabase");
        if (database == null || database.length() == 0) {
            throw new IllegalArgumentException(
                    "Please specifiy context-param \"hsqldbDatabase\".");
        }
        return servletContext.getRealPath(database);
    }

    public void contextDestroyed(ServletContextEvent servletContextEvent) {
        hsqldbServer.stop();
    }
}
